#!/bin/sh
#
# ====================== Change area ============================
MYAISEE=./aisee.bin
# ================== End of Change area =========================
clear
echo ""
echo "What is aiSee ?"
echo ""
echo "aiSee (aka VCG) is a graph visualization tool. It reads"
echo "a textual specification of a graph (consisting of nodes"
echo "and edges), calculates a layout of the graph (i.e. it "
echo "positions the edges and nodes in the plane), followed by "
echo "drawing the graph in a window. aiSee also enables you "
echo "to print the graph."
echo ""
echo "The aiSee Demo Script guides you through ca. 40 example graphs."
echo "Some demonstrate aiSee's features, others are examples taken from"
echo "aiSee (VCG) applications."
echo ""
echo "Now press RETURN to continue ..."
read f
clear
echo ""
echo "To step through the Demo, exit aiSee after each example"
echo "graph by pressing the q key or selecting the QUIT menu"
echo "item of the main menu."
echo "The main menu appears when the middle or right mouse"
echo "button is pressed and held in the aiSee window."
echo ""
echo "Press RETURN to continue ..."
read f
clear
echo ""
echo "Some aiSee Basics:"
echo ""
echo "Navigation: Use the arrow keys to scroll through the graph"
echo "or click on the graph and drag it using the mouse (left button)."
echo ""
echo "Exiting aiSee:"
echo "Key     q                - exit aiSee"
echo ""
echo "Zooming:"
echo "Key     +,-              - zooms in or out"
echo "Key     0                - (zero) sets the scale factor to 100%"
echo "Key     m                - sets the scaling factor to maximum"
echo ""
echo "The m key is very helpful if you get lost while exploring a graph."
echo ""
echo "Press RETURN to show the graph of quickguide.gdl"
read f
eval "$MYAISEE ../samples/quickguide.gdl"
clear
echo ""
echo "Theory of Civilization"
echo "--------------------------------------------------"
echo "This graph shows the relationships between the     "
echo "invention of the wheel and various other sociological "
echo "and scientific developments."
echo "This graph uses the MINBACKWARD layout algorithm."
echo ""
echo "Press q key in the aiSee window to continue."
echo "Press RETURN to show the next graph ..."
read f
eval "$MYAISEE ../samples/civ.gdl"
clear
echo ""
echo "Neighbors in Europe"
echo "-------------------------------------------"
echo "This graph shows the neighbor relations of the"
echo "countries of Europe."
echo "The actual physical location of a country is "
echo "not considered in this force-directed layout algorithm."
echo ""
echo ""
echo "Press q key in the aiSee window to continue."
echo "Press RETURN to show the graph ..."
read f
eval "$MYAISEE ../samples/europe.gdl"
clear
echo ""
echo "Call Graph for DJPEG"
echo "----------------------------------"
echo "This graph shows the call graph of DJPEG"
echo "compiled for a PowerPC processor."
echo "The yellow nodes are folded subgraphs containing the"
echo "control flow graph of a procedure. The blue nodes"
echo "are folded subgraphs containing one basic block."
echo ""
echo "The folded subgraphs can be unfolded or boxed."
echo ""
echo ""
echo "Press q key in the aiSee window to continue."
echo "Press RETURN to show the graph ..."
read f
eval "$MYAISEE ../samples/cgdemo.gdl"
clear
echo ""
echo "Intermediate Representation"
echo "-----------------------------------------"
echo "This graph shows an intermediate representation of the ECGS"
echo "compiler of an FFT program."
echo ""
echo "The folded subgraphs can be unfolded or boxed."
echo ""
echo ""
echo "Press q key in the aiSee window to continue."
echo "Press RETURN to show the graph ..."
read f
eval "$MYAISEE ../samples/irdemo2.gdl"
clear
echo ""
echo "Color Test"
echo "-------------------"
echo "This example shows the default colors that are available"
echo "in color mode. aiSee also supports black-and-white mode."
echo ""
echo "Up to 256 colors can be used at a time."
echo "It is possible to replace the default colors by"
echo "other red/green/blue values."
echo ""
echo ""
echo ""
echo "Press q key in the aiSee window to continue."
echo "Press RETURN to show the graph ..."
read f
eval "$MYAISEE ../samples/colors.gdl"
clear
echo ""
echo "Character Set"
echo "----------------------"
echo "aiSee uses a fully scalable character set. This character"
echo "set is compatible with the ISO Latin 1 PostScript Encoding "
echo "Vector and contains the special national characters for most"
echo "European and North American languages."
echo "The special characters can be accessed by ISO code escapes "
echo "if your computer system does not support 8-bit character codes."
echo "For instance, \\fi252 is the German 'u Umlaut' (ue)."
echo "For instance, \fi252 is the German 'u Umlaut' (ue)."
echo ""
echo ""
echo "Press q key in the aiSee window to continue."
echo "Press RETURN to show the graph ..."
read f
eval "$MYAISEE ../samples/charset.gdl"
clear
echo ""
echo "Loadable fonts"
echo "-----------------------"
echo "aiSee provides a large collection of loadable, scalable fonts."
echo "These fonts are provided in VCF format, a"
echo "bitmap format."
echo "The loadable fonts can be translated into PostScript fonts"
echo "for printing."
echo ""
echo ""
echo "Press q key in the aiSee window to continue."
echo "Press RETURN to show the graph ..."
read f
eval "$MYAISEE ../samples/vcgfont.gdl"
clear
echo ""
echo "Icons"
echo "--------------"
echo "Nodes can also be represented by icons."
echo ""
echo "Press q key in the aiSee window to continue."
echo "Press RETURN to show the graph ..."
read f
eval "$MYAISEE ../samples/laticon.gdl"
clear
echo ""
echo "Shapes"
echo "--------------"
echo "Nodes can be stretched and shrunk individually."
echo "The width, height, text mode and border can be set to "
echo "many values. Edges can be dashed or dotted, and feature   "
echo "different sizes with different arrow sizes."
echo ""
echo ""
echo ""
echo "Press q key in the aiSee window to continue."
echo "Press RETURN to show the graph ..."
read f
eval "$MYAISEE ../samples/forms1.gdl"
clear
echo ""
echo "More Shapes"
echo "-------------------"
echo ""
echo ""
echo ""
echo "Press q key in the aiSee window to continue."
echo "Press RETURN to show the graph ..."
read f
eval "$MYAISEE ../samples/forms2.gdl"
clear
echo ""
echo "More Shapes (cont'd)"
echo "------------------------"
echo ""
echo ""
echo ""
echo "Press q key in the aiSee window to continue."
echo "Press RETURN to show the graph ..."
read f
eval "$MYAISEE ../samples/forms3.gdl"
clear
echo ""
echo "Ports and Arrow Modes"
echo "------------------------------"
echo "Edge arrows appear at node ports. Port sharing"
echo "means that multiple edges may be adjacent to one port."
echo "This occurs when the arrows of all these edges have the"
echo "same appearance (size, color, ...)."
echo "When port sharing is used, it is recommended that only"
echo "a fixed set of rotated arrows is used ('fixed' arrow mode)."
echo "Arrows can be rotated individually when port sharing is not used "
echo "('free' arrow mode)."
echo ""
echo "The next four examples essentially show the same graph."
echo "The first example shows port sharing with fixed arrow mode."
echo ""
echo ""
echo "Press q key in the aiSee window to continue."
read f
eval "$MYAISEE ../samples/pshar1.gdl"
clear
echo ""
echo "Port sharing, free arrow mode."
echo ""
echo ""
echo "Press q key in the aiSee window to continue."
read f
eval "$MYAISEE ../samples/pshar3.gdl"
clear
echo ""
echo "No port sharing, fixed arrow mode."
echo ""
echo ""
echo "Press q key in the aiSee window to continue."
read f
eval "$MYAISEE ../samples/pshar2.gdl"
clear
echo ""
echo "No port sharing, free arrow mode."
echo ""
echo ""
echo "Press q key in the aiSee window to continue."
read f
eval "$MYAISEE ../samples/pshar4.gdl"
clear
echo ""
echo "Diagram"
echo "------------------"
echo "This example shows the influences of various computer"
echo "systems in the development of "
echo "Xerox Star (cf. Johnson, Roberts, et al.: 'The Xerox Star,"
echo "a Retrospective,' IEEE Computer; 11-29, Sept. 1989)."
echo "The diagram has been adapted slightly in order to show the "
echo "visualization possibilities offered by aiSee, not to "
echo "clarify information in the diagram."
echo ""
echo ""
echo "Press q key in the aiSee window to continue."
echo "Press RETURN to show the graph ..."
read f
eval "$MYAISEE ../samples/xerox.gdl"
clear
echo ""
echo "Control Flow Graph of a Program"
echo "------------------------------------------"
echo "This example shows the control flow graph of a program."
echo "The decision branches are formed by rhombuses and "
echo "bent near edges. Near edges are horizontal edges which "
echo "force two adjacent nodes to be directly neighbored at "
echo "the same level. Bent near edges are edges which are bent "
echo "at the label, the source node and the edge label "
echo "forming a near edge. This results in the typical "
echo "appearance of decision branches."
echo ""
echo ""
echo ""
echo "Press q key in the aiSee window to continue."
echo "Press RETURN to show the graph ..."
read f
eval "$MYAISEE ../samples/cfg.gdl"
clear
echo ""
echo "Anchor Points"
echo "---------------------"
echo "It is possible to anchor an edge at each text line"
echo "of a node."
echo "This example shows a list of C structs. It demonstrates"
echo "the usage of anchor points for the visualized debugging"
echo "of data structures."
echo ""
echo ""
echo ""
echo "Press q key in the aiSee window to continue."
echo "Press RETURN to show the graph ..."
read f
eval "$MYAISEE ../samples/structs.gdl"
clear
echo ""
echo "Levels"
echo "---------------"
echo "This example shows how to use level specifications."
echo "Specifying the level of each node is possible."
echo "This enables a node to be artificially placed at the top"
echo "of a graph, for example."
echo ""
echo ""
echo ""
echo "Press q key in the aiSee window to continue."
echo "Press RETURN to show the graph ..."
read f
eval "$MYAISEE ../samples/levels.gdl"
clear
echo ""
echo "Horizontal Layer Sorting"
echo "---------------------------------"
echo "aiSee reorders the nodes at a level so as to avoid"
echo "crossings. This can be suppressed by specifying the"
echo "'horizontal_order' attribute for each node of a level."
echo ""
echo "This feature only works for connected graphs."
echo "It is recommended that this feature is used for the"
echo "level specifications for trees only , where it is clear at"
echo "which level a node appears."
echo ""
echo "This example shows an 'unsorted' graph."
echo "The next example shows a graph in which the"
echo "nodes are sorted in alphabetical order at the various levels."
echo "Press RETURN to show the graph ..."
read f
eval "$MYAISEE ../samples/hunsort.gdl"
clear
echo ""
echo "Now the same graph with a specified horizontal order."
echo ""
echo "Press CONTINUE to show the graph ..."
echo "Press RETURN to show the graph ..."
read f
eval "$MYAISEE ../samples/hsort.gdl"
clear
echo ""
echo "layout_downfactor"
echo "--------------------------"
echo "This graph shows the effect of the 'layout_downfactor'"
echo "attribute on binary trees."
echo ""
echo "Press q key in the aiSee window to continue."
echo "Press RETURN to show the graph ..."
read f
eval "$MYAISEE ../samples/demo002.gdl"
clear
echo ""
echo "Layout of Trees"
echo "-------------------------"
echo ""
echo "Apart from the normal layout algorithm, there is a special"
echo "algorithm for trees. First, a syntax tree is shown which "
echo "is rendered by the standard layout algorithm. Then the same "
echo "tree is shown using the special algorithm for trees."
echo "This graph contains 54 nodes and 53 edges."
echo ""
echo "Press RETURN to show the graph ..."
read f
eval "$MYAISEE ../samples/tree1.gdl"
clear
echo ""
echo "Now, the same graph using the special algorithm for trees."
echo "Press RETURN to show the graph ..."
read f
eval "$MYAISEE ../samples/tree1a.gdl"
clear
echo ""
echo "More Trees"
echo "-------------------"
echo "Trees look attractive if a special version of the Manhattan"
echo "layout method is used: the single-line Manhattan layout."
echo "Here, all horizontal edge segments share the same"
echo "horizontal line."
echo ""
echo "Press RETURN to show the graph ..."
read f
eval "$MYAISEE ../samples/tree2.gdl"
clear
echo ""
echo "Edge Priorities"
echo "------------------------"
echo "A graph may consist of several interwoven graphs, e.g."
echo "a syntax tree and a data dependency graph."
echo "The appearance of a graph should usually only be influenced"
echo "by one graph."
echo "This can be achieved by applying edge priorities."
echo ""
echo "Next, a graph without edge priorities is shown."
echo "Press RETURN to show the graph ..."
read f
eval "$MYAISEE ../samples/annot1.gdl"
clear
echo ""
echo "Now, the same graph with edge priorities."
echo "Press RETURN to show the graph ..."
read f
eval "$MYAISEE ../samples/annot2.gdl"
clear
echo ""
echo "Subgraphs"
echo "------------------"
echo "aiSee2.0 supports subgraphs. A subgraph can be folded"
echo "into a summary node, shown in a box, shown as"
echo "a cluster, wrapped or shown exclusively."
echo ""
echo ""
echo "Press q key in the aiSee window to continue."
echo "Press RETURN to continue ..."
read f
eval "$MYAISEE ../samples/subgraphs.gdl"
clear
echo ""
echo "Intermediate Representation"
echo "------------------------------------"
echo "This graph shows an hierarchical layout of an"
echo "intermediate program representation."
echo ""
echo ""
echo "Press q key in the aiSee window to continue."
echo "Press RETURN to show the graph ..."
read f
eval "$MYAISEE ../samples/irdemo.gdl"
clear
echo ""
echo "Force-Directed Layout"
echo "------------------------------"
echo "aiSee2.0 supports force-directed layout, this"
echo "being particularly well-suited for non-directed graphs."
echo ""
echo ""
echo "Press q key in the aiSee window to continue."
echo "Press RETURN to show the graph ..."
read f
eval "$MYAISEE ../samples/forcedir.gdl"
clear
echo ""
echo "Fish-Eye Views"
echo "-----------------"
echo "Fish-eye views distort the graph so that the"
echo "focus point is magnified while the whole graph"
echo "is visible."
echo ""
echo "The next example is a large graph in normal view."
echo "Then, the graph is displayed in Cartesian fish-eye"
echo "view and polar fish-eye view."
echo ""
echo "This graph contains 484 nodes and 924 edges."
echo "Press RETURN to show the graph ..."
read f
eval "$MYAISEE ../samples/fishex3b.gdl"
clear
echo ""
echo "Now, the same graph in Cartesian fish-eye view."
echo ""
echo "Press RETURN to show the graph ..."
read f
eval "$MYAISEE ../samples/fishex3c.gdl"
clear
echo ""
echo "Cartesian Fish-Eye and Polar Fish-Eye Views"
echo "------------------------------------------------"
echo "Cartesian fish-eye views transform the Cartesian coordinate system"
echo "while polar fish-eye views transform the polar coordinate system."
echo "Polar fish-eye view can be considered to be a mapping of an area "
echo "onto a sphere. Polar fish-eye view does not preserve horizontal"
echo "and vertical lines, whereas Cartesian fish-eye view does."
echo ""
echo "Press RETURN to show the graph ..."
read f
eval "$MYAISEE ../samples/fishex3p.gdl"
clear
echo ""
echo "Another Diagram"
echo "-------------------------"
echo "This diagram shows the dependencies of different shells "
echo "(diagram courtesy of Gansner, Koutsofios, et al.: "
echo "'A Technique for Drawing Graphs,' "
echo "IEEE Trans. Soft. Eng. 19, 3, March 93)."
echo ""
echo "Press RETURN to show the graph ..."
read f
eval "$MYAISEE ../samples/shells.gdl"
clear
echo ""
echo "Intermediate Representation of a Compiler (HIR)"
echo "--------------------------------------------------------"
echo "The next (real-life) example shows the High Intermediate "
echo "Representation (HIR) of a CLaX program. It is a syntax tree "
echo "annotated by types."
echo "The procedure declarations can be seen. The main module is"
echo "actually folded (cf. green triangle)."
echo "If you select Expose/Hide Edges in the Folding menu "
echo "you will see that the edge classes are named in this example."
echo "The TREE layout algorithm is used here."
echo "This graph contains 614 nodes and 613 edges."
echo ""
echo "Press RETURN to show the graph ..."
read f
eval "$MYAISEE ../samples/tstree.gdl"
clear
echo ""
echo "Call Graph"
echo "------------------------"
echo "The yellow nodes are folded subgraphs containing the"
echo "control flow graph of a procedure."
echo ""
echo "The folded subgraphs can be unfolded or boxed."
echo ""
echo "Press q in the aiSee window to continue."
echo "Press RETURN to show the graph ..."
read f
eval "$MYAISEE ../samples/cgdemo2.gdl"
clear
eval "$MYAISEE -silent ../samples/welcome.gdl&"
clear
echo ""
echo "For more information, please contact:"
echo "     AbsInt Angewandte Informatik GmbH"
echo "     http://www.AbsInt.com"
echo "     info@AbsInt.com"
echo ""
echo ""
